## aaruremote 1.0+git20251229

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(aaruremote C)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(TestBigEndian)
set(CMAKE_C_STANDARD 90)

set(MAIN_SOURCES aaruremote.h endian.h hex2bin.c list_devices.c main.c worker.c)

add_library(aaruremotecore ${MAIN_SOURCES})

CHECK_INCLUDE_FILES("endian.h" HAVE_ENDIAN_H)

if (HAVE_ENDIAN_H)
    add_definitions(-DHAVE_ENDIAN_H)
endif ()

if (WII)
    set(CMAKE_C_FLAGS "-mrvl -mcpu=750 -meabi -mhard-float")
    add_definitions(-DGEKKO=1)
    include_directories($ENV{DEVKITPRO}/libogc/include/)
    add_definitions(-D__BYTE_ORDER=4321)
else ()
    if (NOT HAVE_ENDIAN_H AND NOT HAVE_SYS_ENDIAN_H)
        TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
        if (IS_BIG_ENDIAN)
            add_definitions(-D__BYTE_ORDER=4321)
        else ()
            add_definitions(-D__BYTE_ORDER=1234)
        endif ()
    endif ()
endif ()


set(AARU_PORTS "linux;wii;win32;freebsd" CACHE STRING "List of ports to build")
foreach (PORT IN LISTS AARU_PORTS)
    add_subdirectory(${PORT})
endforeach (PORT)

=== freebsd/CMakeLists.txt ===
project(aaruremote-fbsd C)

if (NOT "${CMAKE_SYSTEM}" MATCHES "FreeBSD")
    return()
endif ()

set(PLATFORM_SOURCES list_devices.c freebsd.h device.c scsi.c usb.c ieee1394.c pcmcia.c ata.c sdhci.c ../unix/hello.c
        ../unix/network.c ../unix/unix.c ../unix/unix.h)

CHECK_LIBRARY_EXISTS("cam" cam_open_device "" HAS_CAM)

if (NOT HAS_CAM)
    message(FATAL_ERROR "Cannot find CAM libraries.")
endif ()

add_executable(aaruremote ${PLATFORM_SOURCES})

target_link_libraries(aaruremote aaruremotecore cam)

=== linux/CMakeLists.txt ===
project(aaruremote-linux C)

if (NOT "${CMAKE_SYSTEM}" MATCHES "Linux")
    return()
endif ()

set(PLATFORM_SOURCES list_devices.c linux.h device.c scsi.c usb.c ieee1394.c pcmcia.c ata.c sdhci.c ../unix/hello.c
        ../unix/network.c ../unix/unix.c mmc/ioctl.h ../unix/unix.h)
CHECK_LIBRARY_EXISTS("udev" udev_new "" HAS_UDEV)
CHECK_INCLUDE_FILES("linux/mmc/ioctl.h" HAVE_MMC_IOCTL_H)

add_executable(aaruremote ${PLATFORM_SOURCES})

if (HAS_UDEV)
    target_link_libraries(aaruremote udev)
    add_definitions(-DHAS_UDEV)
endif ()

if (HAVE_MMC_IOCTL_H)
    add_definitions(-DHAS_UAPI_MMC)
endif ()

target_link_libraries(aaruremote aaruremotecore)

=== wii/CMakeLists.txt ===
project(aaruremote-wii C)

if (NOT WII)
    return()
endif ()

set(PLATFORM_SOURCES wii.c hello.c network.c wii.h list_devices.c unsupported.c unimplemented.c)

add_executable(aaruremote-wii ${PLATFORM_SOURCES})
set_target_properties(aaruremote-wii PROPERTIES LINK_FLAGS -L$ENV{DEVKITPRO}/libogc/lib/wii/)
set_target_properties(aaruremote-wii PROPERTIES OUTPUT_NAME aaruremote.elf)
target_link_libraries(aaruremote-wii aaruremotecore -lwiiuse -lbte -logc -lm)

=== win32/CMakeLists.txt ===
project("aaruremote-win32" C)

if (NOT "${CMAKE_SYSTEM}" MATCHES "Windows")
    return()
endif ()

CHECK_INCLUDE_FILES("ntddscsi.h" HAVE_NTDDSCSI_H)
CHECK_INCLUDE_FILES("sffdisk.h" HAVE_SFFDISK_H)
CHECK_INCLUDE_FILES("sddef.h" HAVE_SDDEF_H)

CHECK_TYPE_SIZE(ATA_PASS_THROUGH_EX APTE)
CHECK_TYPE_SIZE(SCSI_PASS_THROUGH_DIRECT SPTD)
CHECK_TYPE_SIZE(SFFDISK_DEVICE_COMMAND_DATA SDCD)
CHECK_TYPE_SIZE(SDCMD_DESCRIPTOR SDCMDD)

if (HAVE_NTDDSCSI_H)
    add_definitions(-DHAS_NTDDSCSI_H)
endif ()

if (HAVE_SFFDISK_H)
    add_definitions(-DHAS_SFFDISK_H)
endif ()

if (HAVE_SDDEF_H)
    add_definitions(-DHAS_SDDEF_H)
endif ()

if (HAVE_APTE)
    add_definitions(-DHAS_APTE)
endif ()

if (HAVE_SPTD)
    add_definitions(-DHAS_SPTD)
endif ()

if (HAVE_SDCD)
    add_definitions(-DHAS_SDCD)
endif ()

if (HAVE_SDCMDD)
    add_definitions(-DHAS_SDCMDD)
endif ()

set(PLATFORM_SOURCES "win32.h" network.c hello.c "win32.c" list_devices.c ata.c device.c ieee1394.c pcmcia.c scsi.c sdhci.c usb.h usb.c ntioctl.h)

add_executable(aaruremote ${PLATFORM_SOURCES})

target_link_libraries(aaruremote aaruremotecore ws2_32 iphlpapi version setupapi cfgmgr32)

=== debian/changelog ===
aaruremote (1.0+git20251229-0ddebs1~debian13) trixie; urgency=medium

  * * Initial release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 15 Feb 2026 23:16:52 +0100

=== debian/control ===
Source: aaruremote
Section: utils
Priority: optional
Maintainer: Nicolas HOUDELOT <nicolas@demosdebs.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libudev-dev
Standards-Version: 4.6.2
Homepage: https://github.com/aaru-dps/aaruremote

Package: aaruremote
Architecture: any
Depends:
 adduser,
 ${shlibs:Depends},
 ${misc:Depends},
Description: Slim application designed to receive commands from aaru instance
 slim miniature application designed to receive device commands from a remote
 Aaru instance, sends it to a local device, and returns the data to the 
 instance.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=1.0+git%cd, \
         repack,compression=xz" \
         https://github.com/aaru-dps/aaruremote \
         HEAD debian uupdate
